;
; ov:Lib v0.26 - FFT Example
;
; (c) :traumatic! 2004/2005
;
;

OpenWindow(0, 0, 0, 256, 200, #PB_Window_SystemMenu | #PB_Window_ScreenCentered, "[ov:Lib] - FFT Example")

CreateImage(0, 256, 100)
CreateImage(1, 256, 100)

Dim fftData.f(2047) ; array to hold fft data
Dim pcmData.b(2047) ; array to hold pcm data

ovInitFFT()

If ovOpen("PurePower.ogg")
  ovPlay()

  Repeat
    fftData() = ovGetSpectrumData()
    pcmData() = ovGetBufferData()
    
    ; draw raw pcm data
    UseImage(0)
    StartDrawing(ImageOutput())
    Box(0, 0, 256, 100)
    x=0
    For i=1 To 2047 Step 4
      Plot(x, 50+pcmData(i), $FF00)
      x+1
    Next 
    LineXY(0, 99, 256, 99, $A0A0A0)
    StopDrawing()
  
    ; draw fft data
    UseImage(1)
    StartDrawing(ImageOutput())
    Box(0, 0, 256, 100,$40)
    For i=1 To 256
      fft.f = fftData(i)*0.0001
      Box(i, 100, 1, -1+fft, $FF00)
    Next
    StopDrawing()
  

    StartDrawing(WindowOutput())
      DrawImage(UseImage(0), 0, 0)
      DrawImage(UseImage(1), 0, 100)
    StopDrawing()
    
    Delay(10)
  Until WindowEvent()=#PB_Event_CloseWindow Or GetAsyncKeyState_(#VK_ESCAPE)
  
Else
  MessageRequester("ov:Lib", "Couldn't open PurePower.ogg") 
EndIf

ovClose()
End
